SystemOrganization addCategory: #TusLibros2!

!Bag methodsFor: '*tuslibros2' stamp: 'PabloFromer 6/17/2012 23:48'!
copy: anotherBag


	|result|
	
	result := Bag new.

	anotherBag do:[ :element |  result add: element].
	
	^result.
	
! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:45'!
bookStore
	
	
	^BookStore catalogWithPrices: self catalogWithPrices dictionaryOfUserPasswords: self dictionaryOfUserPasswords.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 23:59'!
cashier

^(Cashier new) catalogWithPrices: self catalogWithPrices.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:29'!
catalogWithPrices
	
	
	|myCatalog|
	
	myCatalog := Dictionary new.
	
	myCatalog at: 'ISBN-1' put: 1.
	myCatalog at: 'ISBN-2' put: 2.
	
	^myCatalog.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 02:06'!
creatingCartValidRequest
	
	|parametersDictionary|
	
	parametersDictionary := Dictionary new.
	
	parametersDictionary at: 'clientId' put: 'id1'. 
	parametersDictionary at: 'password' put: 'password1'.
	
	^Request methodName: 'createCart' parametersDictionary: parametersDictionary.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:43'!
dictionaryOfUserPasswords 

	|result|
	
	result := Dictionary new.
	
	result at: 'id1' put: 'password1'.
	result at: 'id2' put: 'password2'.
	
	^result.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/22/2012 23:22'!
invalidCreditCard
|expirationDate|

expirationDate := MonthOfYear onMonthNumber: 1 of: 2012.

	^CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: expirationDate.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:54'!
newCart
	
	^(self bookStore) createCartForClientId:'id1' withPassword: 'password1'.
	
	"^Cart catalog: self catalogWithPrices clientId: 1."! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:50'!
restInterface
	
	
	^RestInterface bookStore: self bookStore.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:35'!
test01aCartShouldBeEmptyWhenCreated

	|carro|
	
	carro := self newCart.
	
	self assert: (carro isEmpty).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:49'!
test02aCartShoyldNotBeEmptyAfterABookAdded

	|aCart|

 
	aCart:= self newCart. 
	aCart add: 'ISBN-1'.
	self deny:  (aCart isEmpty).
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:37'!
test03aCartShouldContainABookAdded

	|aCart|

 
	aCart:= self newCart. 
	aCart add: 'ISBN-1'.
	self assert:  (aCart includes: 'ISBN-1').
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:48'!
test04aCartShouldContainTheSameQuantityOfBooksAdded

	|aCart|
	

	aCart:= self newCart.
	aCart add: 'ISBN-1' withOccurrences: 5 .
	self assert: ((aCart occurrencesOf: 'ISBN-1') = 5).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:49'!
test05AfterAddingABookTheOtherBooksRemainInTheCartAndNoOtherBookIsAdded

	|aCart|
	
	
	aCart:= self newCart.
	aCart add: 'ISBN-1'.
	aCart add: 'ISBN-2'.
	
	aCart catalog at: 'ISBN-3' put: 3.
	
	aCart add: 'ISBN-3'.	
		
	self assert: (aCart includes: 'ISBN-1').
	self assert: (aCart includes: 'ISBN-2').
	self assert: (aCart includes: 'ISBN-3').
	self assert:(aCart items size = 3).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:40'!
test06AddingABookNotInTheCatalogRaisesError

	
	
	self
		should: [ self newCart add: 'ISBnNotInCatalog']
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'BookNotInTheCatalog' ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:40'!
test07AddingNegativeQuantitiesToACartRaisesError

	
	
	
	self
		should: [ self newCart add: 'ISBN-1' withOccurrences: (-1) ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'CannotAddNegativeQuantities' ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:51'!
test08CheckingOutAnEmptyCart

	|cart|
	
	cart:= self newCart.
	
	self
		should: [ self cashier checkOutCart: cart forCreditCard: self validCreditCard ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'CannotCheckOutEmptyCart'.
			self assert:(self cashier totalCallsToMerchantProcessor = 0).
			self assert: (self cashier handedTickets size = 0) ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:51'!
test09CheckingOutWithExpiredCreditCard

	|cart|
	
	cart:= self newCart.
	
	cart add: 'ISBN-1'.
	
	self
		should: [ self cashier checkOutCart: cart forCreditCard: self invalidCreditCard ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'CannotCheckWithExpiratedCard'.
			self assert:(self cashier totalCallsToMerchantProcessor = 0).
			self assert: (self cashier handedTickets size = 0) ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:51'!
test10ChekingOutValidCartAndValidCreditCard

	|itemsSaledAfterValidOperation cart cart2 cashier ticket ticket2|
	
	cashier := self cashier.
	
	cart := self newCart.
	cart2 := self newCart.
	
	cart add: 'ISBN-1'.
	
	cart add: 'ISBN-2'.
	
	ticket:= cashier checkOutCart: cart forCreditCard: self validCreditCard.
	
	self assert: (cashier handedTickets includes: ticket).
	self assert: (ticket items includes: (ItemWithPrice isbn: 'ISBN-1' price: 1) ).
	self assert: (ticket items includes: (ItemWithPrice isbn: 'ISBN-2' price: 2) ).
	self assert: (cashier totalCallsToMerchantProcessor = 1).
	self assert: (ticket total = 3).
	self assert: (ticket clientId = cart clientId).
	
	cart2 add: 'ISBN-2'.
	ticket2:= cashier checkOutCart: cart2 forCreditCard: self validCreditCard . 
	
	self assert: (cashier totalCallsToMerchantProcessor = 2).
	self assert: (ticket2 total = 2).
	self deny: (ticket2 items includes: (ItemWithPrice isbn: 'ISBN-1' price: 1)).
	self assert: (ticket2 items includes: (ItemWithPrice isbn: 'ISBN-2' price: 2)).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:53'!
test11ThereAreNoTicketsHandedWhenCashierIsJustCreated

	|cashier|
	
	cashier := self cashier.
		
	self assert: (cashier handedTickets size = 0).
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:54'!
test12totalCallsToMerchantProcessorWhenCashierJustCreatedIsZero

	|cashier|
	
	cashier := self cashier.
	
	self assert: (cashier totalCallsToMerchantProcessor = 0).
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:43'!
test13CheckingOutWithExpiredCreditCard

	|cart m|
	
	cart:= self newCart.
	
	cart add: 'ISBN-1'.
	
	[ self cashier checkOutCart: cart forCreditCard: self invalidCreditCard ]on: Error   do:[ :anError | m:= anError messageText ]. 

	self
		should: [ self cashier checkOutCart: cart forCreditCard: self invalidCreditCard ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'CannotCheckWithExpiratedCard'.
			self assert:(self cashier totalCallsToMerchantProcessor = 0).
			self assert: (self cashier handedTickets size = 0) ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 02:36'!
test13CreateCartWithValidCredentials

	|response|
	
	response := self restInterface takeRequest: self creatingCartValidRequest.
	
	self assert: (response HTTPStatus = 200).
	
	

	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 00:10'!
validCreditCard

	|goodExpirationDate|
	

	goodExpirationDate := MonthOfYear onMonthNumber: 1 of: ((self validExpirationDate yearNumber) +1 ). 
	
	^CreditCard ownedBy: (self validOwnerName) identifiedBy: (self validNumber) expiresOn: goodExpirationDate.! !

!TusLibrosTest methodsFor: 'test objects' stamp: 'FromerMaffongelli 6/18/2012 21:02'!
validExpirationDate
	
	^ MonthOfYear januaryOf: 2012! !

!TusLibrosTest methodsFor: 'test objects' stamp: 'FromerMaffongelli 6/18/2012 21:02'!
validNumber
	
	 ^ '0123456789012345'! !

!TusLibrosTest methodsFor: 'test objects' stamp: 'FromerMaffongelli 6/18/2012 21:02'!
validOwnerName

	^ 'Pepe Sanchez'! !

Object subclass: #BookStore
	instanceVariableNames: 'catalogWithPrices dictionaryOfUserPasswords dictionaryOfCartIdToCarts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!BookStore class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:38'!
catalogWithPrices: aCatalogWithPrices dictionaryOfUserPasswords: aDictionaryOfUserPasswords

	^(self new) catalogWithPrices: aCatalogWithPrices dictionaryOfUserPasswords: aDictionaryOfUserPasswords.! !

!BookStore methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:40'!
catalogWithPrices

	
	^catalogWithPrices.! !

!BookStore methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:38'!
catalogWithPrices: aCatalogWithPrices dictionaryOfUserPasswords: aDictionaryOfUserPasswords

	
	catalogWithPrices:= aCatalogWithPrices.
	dictionaryOfUserPasswords:= aDictionaryOfUserPasswords.! !

!BookStore methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 02:00'!
createCartForClientId:aClientId withPassword: aPassword
	
	|clientIdExists credentialsForUserAreOk cart|
	
	clientIdExists := (dictionaryOfUserPasswords keys asBag includes: aClientId).
	
	 (clientIdExists) ifTrue: [credentialsForUserAreOk := (aPassword = (dictionaryOfUserPasswords at: aClientId) )] ifFalse:[credentialsForUserAreOk := false]. 
	
	(credentialsForUserAreOk) 
		ifTrue: [
			cart:=Cart catalog: self catalogWithPrices clientId: aClientId.
			dictionaryOfCartIdToCarts at: cart id put: cart.
			^cart. ] 
		ifFalse: [
			self error: 'Invalid user credentials' ]. 
	! !

!BookStore methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:39'!
dictionaryOfUserPasswords

	
	^dictionaryOfUserPasswords.! !

!BookStore methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:36'!
initialize 
	
   dictionaryOfCartIdToCarts := Dictionary new.
	! !

Object subclass: #Cart
	instanceVariableNames: 'items catalog clientId id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

Cart class
	instanceVariableNames: 'nextCartId'!

Cart class
	instanceVariableNames: 'nextCartId'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 23:29'!
catalog: aCatalog clientId: aClientId

	nextCartId := nextCartId + 1.
	^(self new) catalog: aCatalog clientId: aClientId.! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 23:28'!
initialize 

	nextCartId := 0.! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 23:31'!
nextCartId
	
	^nextCartId.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:33'!
add: aBook

	(catalog includesKey: aBook) ifTrue: [items add: aBook]
	
	 ifFalse: [self error: 'BookNotInTheCatalog']
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:33'!
add: aBook withOccurrences: aSmallInteger

	(catalog includesKey: aBook) ifFalse: [self error: 'BookNotInTheCatalog'].
	
	(aSmallInteger > 0) ifFalse: [self error: 'CannotAddNegativeQuantities'].
	
	items add: aBook withOccurrences: aSmallInteger.
	
	
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 22:34'!
catalog

	^catalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:34'!
catalog: aCatalog clientId: aClientId

	catalog:= aCatalog.
	clientId := aClientId.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:49'!
clientId

	^clientId.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 23:31'!
id

	^id.
	
	
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:34'!
includes: aBook

^items includes: aBook.


	
	
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 23:31'!
initialize

	items := Bag new.
	id := Cart nextCartId.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 22:47'!
isEmpty

^items size  = 0.


	
	
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:59'!
items

	^items.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 23:25'!
occurrencesOf: aBook

	^items occurrencesOf: aBook.! !

Object subclass: #Cashier
	instanceVariableNames: 'catalogWithPrices merchantProcessorInterface handedTickets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:31'!
catalogWithPrices

	^catalogWithPrices.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:07'!
catalogWithPrices: aCatalogWithPrices

catalogWithPrices:=aCatalogWithPrices.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:49'!
checkOutCart: aCart forCreditCard: aCreditCard

|ticket currentMonthOfYear|

self catalogWithPrices: aCart catalog.

currentMonthOfYear := MonthOfYear onMonthNumber: 2 of: 2012. 

ticket := Ticket clientId: aCart clientId.


(aCart isEmpty) ifTrue: [self error: 'CannotCheckOutEmptyCart'].


(aCreditCard isExpiredOn: currentMonthOfYear  ) ifTrue: [self error: 'CannotCheckWithExpiratedCard'].

((merchantProcessorInterface chargeThisAmountOfMoney: (self totalAmountForCart: aCart) forthisCreditCard: aCreditCard) = '0|OK') ifTrue: [
	"(aCart items) do:[ :item | itemsSaled add: item ]."
	
	(aCart items) do:[ : item | ticket items add: (ItemWithPrice isbn: item price: (catalogWithPrices at: item) ) ].
	
	handedTickets add: ticket.
	
	
	
	^ticket].

! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 12:09'!
handedTickets

^handedTickets.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 11:57'!
initialize 

	merchantProcessorInterface := MerchantProcessorInterface new.
	handedTickets := Bag new.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 16:51'!
totalAmountForCart: aCart

	|total|
	
	total:=0.

	(aCart items) do:[ :item | total := total + (catalogWithPrices at: item) ].
	
	^total.
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:51'!
totalCallsToMerchantProcessor

	^merchantProcessorInterface totalCallsToMerchantProcessor.! !

Object subclass: #ItemWithPrice
	instanceVariableNames: 'isbn price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!ItemWithPrice class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 00:25'!
isbn:aISBN price:aPrice
	
	
	^(self new) isbn: aISBN price:aPrice. ! !

!ItemWithPrice methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 01:30'!
= anotherBookSold.

	^(isbn = anotherBookSold isbn) and: (price = anotherBookSold price).! !

!ItemWithPrice methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 10:29'!
hash

	^isbn hash + (price hash * (55555))! !

!ItemWithPrice methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 20:13'!
isbn
	^isbn.! !

!ItemWithPrice methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 18:30'!
isbn:aISBN price:aPrice

	isbn := aISBN.
	price := aPrice.! !

!ItemWithPrice methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 20:13'!
price

	^price.! !

Object subclass: #MerchantProcessorInterface
	instanceVariableNames: 'totalCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:50'!
chargeThisAmountOfMoney:anAmountOfMoney forthisCreditCard: aCreditCard

totalCalls := totalCalls + 1.

^'0|OK'.! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:49'!
initialize

	totalCalls := 0.! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 13:51'!
totalCallsToMerchantProcessor



^totalCalls.! !

Object subclass: #Request
	instanceVariableNames: 'methodName parametersDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!Request class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 18:50'!
methodName: aMethodName parametersDictionary: aParametersDictionary

 ^(self new) methodName: aMethodName parametersDictionary: aParametersDictionary.! !

!Request methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 18:49'!
methodName

	^ methodName.! !

!Request methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 18:49'!
methodName: aMethodName parametersDictionary: aParametersDictionary

	methodName := aMethodName.
	parametersDictionary := aParametersDictionary.! !

!Request methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 18:49'!
parametersDictionary
	
	^parametersDictionary.! !

Object subclass: #Response
	instanceVariableNames: 'HTTPStatus output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!Response class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 19:03'!
HTTPStatus: aStatus output: anOutput

	^(self new) HTTPStatus: aStatus output: anOutput.! !

!Response methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 19:04'!
HTTPStatus

^HTTPStatus.! !

!Response methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 19:02'!
HTTPStatus: aStatus output: anOutput

	HTTPStatus:= aStatus.
	output := anOutput.! !

!Response methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 19:04'!
output

	^output.! !

Object subclass: #RestInterface
	instanceVariableNames: 'bookStore dictionaryOfMethodNamesToBlocks dictionaryOfCartIdToLastOperationTimeStamp dictionaryOfMethodNamesToBagWithParametersNeeded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!RestInterface class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:48'!
bookStore: aBookStore

^(self new) bookStore: aBookStore.! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:24'!
blockForAddingToCart

^[:parametersDictionary| |response clientId password output clientIdExists credentialsForUserAreOk cart cartId| 
	
	clientId := parametersDictionary at: 'clientId'.
	password := parametersDictionary at: 'password'.
	
	clientIdExists := (dictionaryOfUserPasswords keys asBag includes: clientId).
	
	credentialsForUserAreOk := (clientIdExists) ifTrue: [ password = dictionaryOfUserPasswords at: clientId ] ifFalse:[false]. 
	
	
	output:= (credentialsForUserAreOk) ifTrue: [ cart:= Cart catalog: cashier catalogWithPrices  clientId: clientId.
		cartId := cart id.
		dictionaryOfCartIdToCarts at: cartId put: cart.
		^'0|', (cartId asString).
		]
	 	ifFalse: [^'1|InvalidCredentials' ]. 
	
	response:= Response HTTPStatus: 200 output: output. ]! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:24'!
blockForCheckingOutCart

^[:parametersDictionary| |response clientId password output clientIdExists credentialsForUserAreOk cart cartId| 
	
	clientId := parametersDictionary at: 'clientId'.
	password := parametersDictionary at: 'password'.
	
	clientIdExists := (dictionaryOfUserPasswords keys asBag includes: clientId).
	
	credentialsForUserAreOk := (clientIdExists) ifTrue: [ password = dictionaryOfUserPasswords at: clientId ] ifFalse:[false]. 
	
	
	output:= (credentialsForUserAreOk) ifTrue: [ cart:= Cart catalog: cashier catalogWithPrices  clientId: clientId.
		cartId := cart id.
		dictionaryOfCartIdToCarts at: cartId put: cart.
		^'0|', (cartId asString).
		]
	 	ifFalse: [^'1|InvalidCredentials' ]. 
	
	response:= Response HTTPStatus: 200 output: output. ]! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 02:30'!
blockForCreatingCart

^[:parametersDictionary| |response clientId password output clientIdExists credentialsForUserAreOk cart| 
	
	clientId := parametersDictionary at: 'clientId'.
	password := parametersDictionary at: 'password'.
	
	[cart := bookStore createCartForClientId: clientId withPassword: password.
	output:= '0|', (cart id asString).] on: Error   do:[ :anError | output:= '1', anError messageText ]. 

	response:= Response HTTPStatus: 200 output: output. ]! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:24'!
blockForListingCart

^[:parametersDictionary| |response clientId password output clientIdExists credentialsForUserAreOk cart cartId| 
	
	clientId := parametersDictionary at: 'clientId'.
	password := parametersDictionary at: 'password'.
	
	clientIdExists := (dictionaryOfUserPasswords keys asBag includes: clientId).
	
	credentialsForUserAreOk := (clientIdExists) ifTrue: [ password = dictionaryOfUserPasswords at: clientId ] ifFalse:[false]. 
	
	
	output:= (credentialsForUserAreOk) ifTrue: [ cart:= Cart catalog: cashier catalogWithPrices  clientId: clientId.
		cartId := cart id.
		dictionaryOfCartIdToCarts at: cartId put: cart.
		^'0|', (cartId asString).
		]
	 	ifFalse: [^'1|InvalidCredentials' ]. 
	
	response:= Response HTTPStatus: 200 output: output. ]! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:24'!
blockForListingClientPurchases

^[:parametersDictionary| |response clientId password output clientIdExists credentialsForUserAreOk cart cartId| 
	
	clientId := parametersDictionary at: 'clientId'.
	password := parametersDictionary at: 'password'.
	
	clientIdExists := (dictionaryOfUserPasswords keys asBag includes: clientId).
	
	credentialsForUserAreOk := (clientIdExists) ifTrue: [ password = dictionaryOfUserPasswords at: clientId ] ifFalse:[false]. 
	
	
	output:= (credentialsForUserAreOk) ifTrue: [ cart:= Cart catalog: cashier catalogWithPrices  clientId: clientId.
		cartId := cart id.
		dictionaryOfCartIdToCarts at: cartId put: cart.
		^'0|', (cartId asString).
		]
	 	ifFalse: [^'1|InvalidCredentials' ]. 
	
	response:= Response HTTPStatus: 200 output: output. ]! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 02:18'!
bookStore: aBookStore

	bookStore := aBookStore.! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 00:00'!
checkCartIsValidAndProcessRequest: aRequest

	|cartId|
	
	cartId := aRequest parametersDictionary at: 'cartId'.
	
	(self lastOperationWithCartHappenedLessThan30MinutesAgo: cartId)ifFalse: [self error:'Can no longer operate with this cart, time expired.'].	
		
	dictionaryOfCartIdToLastOperationTimeStamp at: cartId put: TimeStamp now. 
	
	^self processRequest: aRequest.! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 01:46'!
initialize 

	dictionaryOfCartIdToLastOperationTimeStamp := Dictionary new.
	
	dictionaryOfMethodNamesToBlocks:= Dictionary new.
	dictionaryOfMethodNamesToBlocks at: 'createCart' put: self blockForCreatingCart. 
	dictionaryOfMethodNamesToBlocks at: 'addToCart' put: self blockForAddingToCart.
	dictionaryOfMethodNamesToBlocks at: 'listCart' put: self blockForListingCart.
	dictionaryOfMethodNamesToBlocks at: 'checkOutCart' put: self blockForCheckingOutCart.
	dictionaryOfMethodNamesToBlocks at: 'listPurchases' put: self blockForListingClientPurchases. 
	
	dictionaryOfMethodNamesToBagWithParametersNeeded := Dictionary new.
	dictionaryOfMethodNamesToBagWithParametersNeeded at: 'createCart' put: self parametersForCreatringCartMethod.
	dictionaryOfMethodNamesToBagWithParametersNeeded at: 'addToCart' put: self parametersForAddingItemToCartMethod.
	dictionaryOfMethodNamesToBagWithParametersNeeded at: 'listCart' put: self parametersForListingCartMethod.
	dictionaryOfMethodNamesToBagWithParametersNeeded at: 'checkOutCart' put: self parametersForCheckingOutCartMethod.
	dictionaryOfMethodNamesToBagWithParametersNeeded at: 'listPurchases' put: self parametersForListingClientPurchasesMethod.
	
	
! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 00:11'!
lastOperationWithCartHappenedLessThan30MinutesAgo: aCartId


	^(((TimeStamp now) - (dictionaryOfCartIdToLastOperationTimeStamp at: aCartId)) minutes) < 30.! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:14'!
parametersForAddingItemToCartMethod

	|result|
	
	result := Bag new.
	
	result add: 'cartId'.
	result add: 'bookIsbn'.
	result add: 'bookQuantity'.
	
	 ^result.

	
	
! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:16'!
parametersForCheckingOutCartMethod

	|result|
	
	result := Bag new.
	
	result add: 'cartId'.
	result add: 'ccn'.
	result add: 'cced'.
	result add: 'cco'.
	
	 ^result.

	
	
! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:12'!
parametersForCreatringCartMethod

	|result|
	
	result := Bag new.
	
	result add: 'clientId'.
	result add: 'password'.
	
	 ^result.

	
	
! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:15'!
parametersForListingCartMethod

	|result|
	
	result := Bag new.
	
	result add: 'cartId'.
	
	 ^result.

	
	
! !

!RestInterface methodsFor: 'private' stamp: 'PabloFromer 6/24/2012 00:17'!
parametersForListingClientPurchasesMethod

			
	 ^self parametersForCreatringCartMethod.

	
	
! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/24/2012 02:28'!
processRequest: aRequest
	
	|block parameterKeys methodName allMethodNames|
	
	allMethodNames := dictionaryOfMethodNamesToBagWithParametersNeeded keys asBag.
	
	methodName := aRequest methodName.
	
	parameterKeys := aRequest parametersDictionary keys asBag.
	
	(parameterKeys = (dictionaryOfMethodNamesToBagWithParametersNeeded at: methodName)) ifFalse: [^Response HTTPStatus: 400 output: ''].
	
	
	
	(allMethodNames includes: methodName) ifFalse:  [^Response HTTPStatus: 400 output: ''].
	
	block := dictionaryOfMethodNamesToBlocks at: aRequest methodName.
	
	^block value: aRequest parametersDictionary.! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 22:25'!
takeRequest: aRequest

	(aRequest parametersDictionary includesKey: 'cartId') ifTrue: [self checkCartIsValidAndProcessRequest: aRequest ]
	
	ifFalse: [^self processRequest: aRequest].! !

Object subclass: #Ticket
	instanceVariableNames: 'items clientId timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!Ticket class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:47'!
clientId: aClientId

	^(self new) clientId: aClientId.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 12:49'!
= anotherTicket


	^items = anotherTicket items.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:50'!
clientId

	^clientId.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:47'!
clientId: aClientId

	clientId := aClientId.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:42'!
hash

	|result|
	
	result:= 0.

	items do: [:item |result := result + item hash].
	
	result := result + timestamp hash.
	
	result := result + clientId hash.
	
	^result.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 17:45'!
initialize

	items:= Bag new.
	timestamp := TimeStamp now.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:45'!
items

	 ^items.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:28'!
items: aBag


	items:= aBag.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/23/2012 11:09'!
total

|result|

result:= 0.
	
	
	items do: [:item | result := (result) + item price].
	
	^result.! !
Cart initialize!
